/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.heuristiclab.okb.ecj;

import com.heuristiclab.okb.service.administration.AdministrationServiceUtil;
import com.heurisitclab.okb.service.runcreation.Algorithm;
import com.heurisitclab.okb.service.runcreation.RunCreationUtil;
import com.heuristiclab.okb.service.administration.Platform;

import java.util.Map;

import ec.EvolutionState;
import ec.Statistics;
import ec.util.Parameter;

import java.beans.XMLEncoder;
import java.io.ByteArrayOutputStream;
import java.util.HashMap;

/**
 *
 * @author fab
 */
public class OKBStatistics extends Statistics{

    public static final String ECJ_PLATFORM_NAME = "ECJ";
    public static final String OKB_PARAMETER_NAME = "okb.parameter";
    public static final String OKB_PARAMETER_SEED = "okb.parameter.seed";
    private Platform ecjPlatform;
    


    @Override
    public void setup(EvolutionState state, Parameter base) {
        super.setup(state, base);
    
        

    }



    @Override
    public void postInitializationStatistics(EvolutionState state) {
        super.postInitializationStatistics(state);
    }

    @Override
    public void finalStatistics(EvolutionState state, int result) {
        super.finalStatistics(state, result);

       ecjPlatform = AdministrationServiceUtil.getPlattform(ECJ_PLATFORM_NAME);
       Algorithm algorithm = RunCreationUtil.getAlgorithm(state.evaluator.getClass().getName(), ecjPlatform.getName());
       Map<String, String> parameters = getParametersToSend(state);
       ByteArrayOutputStream o = new ByteArrayOutputStream();
       new XMLEncoder(o).writeObject(state);


        
        RunCreationUtil.createRun(parameters,result,new String(o.toByteArray()),getSeed(state),algorithm.getId() , ecjPlatform.getId());

    }

    private int getSeed(EvolutionState state)
    {
        int returnValue = 0;
        String seedName = state.parameters.getString(new Parameter(OKB_PARAMETER_SEED),null);
        if(seedName == null)
            throw new IllegalArgumentException("no seed given!");

        returnValue = state.parameters.getInt(new Parameter(seedName),null);

        return returnValue;
    }


    private Map<String, String> getParametersToSend(EvolutionState state)
    {
        Map<String, String> returnValue = new HashMap<String, String>();
        for(String name : state.parameters.getString(new Parameter(OKB_PARAMETER_NAME),null).split(";"))
        {
            String tmp = state.parameters.getString(new Parameter(name.trim()),null);
            if(tmp == null)
                returnValue.put(name, name);
            else
                returnValue.put(name, tmp);

        }

        return returnValue;
    }
    
    
    
}
